// Created by: X
// Web: http://www.createdbyx.com/
// Date: July 8, 2008
// =============================================

using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;

// TODO: replace this with the type you want to read.
using TRead = System.IO.MemoryStream;

namespace StreamContentReader
{
    /// <summary>
    /// This class will be instantiated by the XNA Framework Content
    /// Pipeline to read the specified data type from binary .xnb format.
    /// 
    /// Unlike the other Content Pipeline support classes, this should
    /// be a part of your main game project, and not the Content Pipeline
    /// Extension Library project.
    /// </summary>
    public class StreamContentReader : ContentTypeReader<TRead>
    {
        protected override TRead Read(ContentReader input, TRead existingInstance)
        {
            System.Diagnostics.Debugger.Launch();
            // calc the number of characters that will be read
            int count = (int)(input.BaseStream.Length - input.BaseStream.Position);

            // create a string reader to store the data that will be read
            System.IO.MemoryStream data = new System.IO.MemoryStream(count);

            // read "count" number of characters from the input object and write the date to the memory stream
            data.Write(input.ReadBytes(count), 0, count);
            data.Seek(0, System.IO.SeekOrigin.Begin);

            // return the reference the Doc varible
            return data;
        }
    }
}
